this.name					= "gates_masterScript";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "WorldScript for Gates OXP.";
this.version				= "1.13";

this.startUp = function()
	{
	this.defenderTime = clock.absoluteSeconds; 
	}
	

this.shipWillExitWitchspace = function()
	{
	if(system.isInterstellarSpace || system.sun.isGoingNova || system.sun.hasGoneNova) 
		{ // stop the script if interstellar space, or system is going Nova(to allow Nova mission unhindered) or indeed if it has gone nova already.
		return;
		}

	this.setUpGates();
	}

this.shipWillLaunchFromStation = function(station)
	{
	if(station.isMainStation)
		{
		this.setUpGates();
		delete this.shipWillLaunchFromStation;
		}
	}

this.setUpGates = function()
	{
	if(system.countShipsWithRole("gates_jumpGate") > 0 || system.techLevel < 7 || system.government < 4 || this.scrambledPseudoRandom(34.12) < 0.25)
		{
		return;
		}

	log("Adding jump gates to the " + system.name + " system");

	system.legacy_addShipsAt("gates_jumpGate", 1, "wpu", [0,0,0.02]);
      
    this.xOffset = (Math.random() * 10000); // x offset between 0 and 10km
	this.yOffset = (Math.random() * 10000); // y offset between 0 and 10km
	this.zOffset = (Math.random() * 25000) + 15000; // z offset between 15 and 40km

      if(Math.random() > 0.5) // 50:50 chance of offsetting in the other direction
         {
         this.xOffset = -this.xOffset;
         }
      if(Math.random() > 0.5) // 50:50 chance of offsetting in the other direction
         {
         this.yOffset = -this.yOffset;
         }
	
	if(system.mainStation)
		{ system.legacy_addShipsAtPrecisely("gates_jumpGate", 1, "abs", system.mainStation.position.subtract([this.xOffset, this.yOffset, this.zOffset]));}
	}

this.scrambledPseudoRandom = function(salt) // Ahruman's random number generator.
	{
    // Convert from float in [0..1) with 24 bits of precision to integer.
    var n = Math.floor(system.pseudoRandomNumber * 16777216.0);
   
    // Add salt to enable generation of different sequences.
    n += salt;
   
    // Scramble with basic LCG psuedo-random number generator.
    n = (214013 * n + 2531011) & 0xFFFFFFFF;
    n = (214013 * n + 2531011) & 0xFFFFFFFF;
    n = (214013 * n + 2531011) & 0xFFFFFFFF;
   
    // Convert from (effectively) 32-bit signed integer to float in [0..1).
    return n / 4294967296.0 + 0.5;
	};	
	
// the function below is referenced by the gates themselves via their own script, or are assigned to NPC ships using the gates.

this.defenderAllowed = function() 
	{ 
	if(this.defenderTime && (clock.absoluteSeconds - this.defenderTime) > 20) 
		{ 
		this.defenderTime = clock.absoluteSeconds; 
		return true; 
		} 
	else 
		{
		return false; 
		}
	}

